#include <stdio.h>
#include <stdlib.h>

struct esame {
       long matricola;
       int voto,codice;
       };
       
void leggi(struct esame *e)
{
     printf("Matricola ");
     scanf("%ld",&e->matricola);
     printf("Voto ");
     scanf("%d",&e->voto);
     printf("Codice materia ");
     scanf("%d",&e->codice);
}


void inserisci(struct esame *T[3], int *N, struct esame x)
{ 
     struct esame *Va;
     int i;
     
     i=x.codice;
     Va=realloc(T[i],sizeof(struct esame)*(N[i]+1));
     if(Va)
       {
           T[i]=Va;
           T[i][N[i]]=x;
           N[i]++;
       }
       else printf("errore allocazione\n");
}       

void visualizza (struct esame *T[3],int N[3])
{
 int r,i;
 
 
 printf("Codice materia ");
 scanf("%d",&r);
 for(i=0;i<N[r];i++)
  {
    printf("Matricola : %ld\n",T[r][i].matricola);
    printf("Voto: %d\n\n",T[r][i].voto);
  }
}
  
void salva (struct esame *T[3], int N[3])
{
     FILE *pf;
     int i,j;
     
     pf=fopen("esami.txt","w");
     if(pf)
        {   
            for(i=0;i<3;i++)
              for(j=0;j<N[i];j++)
               
                 fwrite(&T[i][j],sizeof(struct esame),1,pf);
            fclose(pf);
        }
     else printf("errore\n");
}


void carica(struct esame *T[3], int N[3])
{
     FILE *pf;
     struct esame x;
     int i;
     
     pf=fopen("esami.txt","r");
     if(pf)
      {  while(fread(&x,sizeof(struct esame),1,pf))
          {  i=x.codice;
             inserisci(T,N,x);
          }
          fclose(pf);
      }
     else printf("errore in lettura\n");
}
     
          
     

main() {
       
 struct esame *T[3],e;
 int N[3];
 int scelta,i;      
 
 
  /* inizializzazione */ 
    for(i=0;i<3;i++)
       {
        T[i]=NULL;
        N[i]=0;
        }
        
     do {
         printf("\nScegli\n1) Inserisci\n");
         printf("2) Visualizza\n3) Salva\n");
         printf("4) Carica\n0) fine\n\n");
         scanf("%d",&scelta);
         switch(scelta) {
           case 1:  leggi(&e);
                    inserisci(T,N,e);
                    break;
           case 2:  visualizza(T,N);
                    break;
           case 3:  salva(T,N);
                    break;
           case 4:  carica(T,N);
                    break;
           default:;
           } 
           } while (scelta!=0);
           
           
           for(i=0;i<3;i++)
             free(T[i]);
}
           
    
