#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct persona {
       char codfisc[17];
       int codice;
       };

void leggi(struct persona *p);
void inserisci(struct persona **V, int *pn);
void visualizza(struct persona *V, int n);
void cancella(struct persona **V, int *pn);
void salva(struct persona *V, int n);
void carica(struct persona **V, int *pn);


main() {
       
       struct persona *V;
       int n;
       int scelta;
       
       /*inizializzazione del vettore*/
       n=0;
       V=NULL;
       
       do {
           printf("\nScegli\n1) Inserisci\n");
           printf("2) Visualizza\n3)Cancella\n");
           printf("4)Salva\n5)Carica\n0)Fine)\n");
           scanf("%d",&scelta);
           switch(scelta) {
           case 1:  inserisci(&V,&n);
                    break;
           case 2:  visualizza(V,n);
                    break;
           case 3:  cancella(&V,&n);
                    break;
           case 4:  salva(V,n);
                    break;
           case 5:  carica(&V,&n);
                    break;
           default:; }
         } while(scelta!=0);
  
   free(V);        
}         

void leggi(struct persona *p)
{
     printf("Codice fiscale ");
     scanf("%s",(*p).codfisc);
     /* oppure scanf("%s",p->codfisc); */
     printf("Codice mansione ");
     scanf("%d",&p->codice);
     /*  scanf("%d",&(*p).codice); */
}

void inserisci(struct persona **V, int *pn)
{
     struct persona *Va;
     struct persona x;
     
     leggi(&x);
     Va= realloc(*V,sizeof(struct persona)*(*pn+1));
     if(Va!=NULL)
      { *V=Va;
        (*V)[*pn]=x;
        (*pn)++;
      }
     else printf("Memoria non allocata\n");
} 
     

void visualizza(struct persona *V, int n)
{
     int i;
     
     for(i=0;i<n;i++)
       {
        printf("Cod. fiscale: %s\n",V[i].codfisc);
        printf("Cod. mansione: %d\n",V[i].codice);
       }
}
           
void cancella(struct persona **V, int *pn)
{
 char codfisc[17];
 int i,p;
 /* ricerca*/
 printf("Cod. fiscale ");
 scanf("%s",codfisc);
 for(p=0;p<*pn;p++)
   if(strcmp(codfisc,(*V)[p].codfisc)==0)
     /* trovato */
       break;
 if(p<*pn)  /* se trovato */      
  {  /* eliminazione */
      /* spostamento degli elementi verso sinistra */
      for(i=p;i<*pn-1;i++)
       (*V)[i]=(*V)[i+1];
      
      (*pn)--;
      
      *V=realloc(*V,sizeof(struct persona)*(*pn));
 }
 else /* non trovato */
      printf("Elemento non trovato\n");
} 
       
       


void salva(struct persona *V, int n)
{
     FILE *pf;
     int i; 
     
     pf=fopen("persone.txt","w");
     if(pf)
       {  for(i=0;i<n;i++)
            fwrite(&V[i],sizeof(struct persona),1,pf);
          fclose(pf);
       }
     else printf("ERRORE\n");
}

void carica(struct persona **V, int *pn)
{
  FILE *pf;
  struct persona x,*Va;
  
  pf=fopen("persone.txt","r");
  if(pf)
     {  while(fread(&x,sizeof(struct persona),1,pf))
         {          
           Va=realloc(*V,sizeof(struct persona)*(*pn+1));
           if(Va!=NULL)
             {
               *V=Va;
               (*V)[*pn]=x;
               (*pn)++;
             }
           else printf("Errore allocazione\n");
         }
         fclose(pf);
     }
     else printf("errore in lettura\n");
}  
       
       
